(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('styled-components')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'styled-components'], factory) :
  (global = global || self, factory(global.HoverCard = {}, global.React, global.styled));
}(this, function (exports, React, styled) { 'use strict';

  styled = styled && styled.hasOwnProperty('default') ? styled['default'] : styled;

  function _taggedTemplateLiteral(strings, raw) {
    if (!raw) {
      raw = strings.slice(0);
    }

    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  function _templateObject2() {
    var data = _taggedTemplateLiteral(["\n  position: relative;\n"]);

    _templateObject2 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject() {
    var data = _taggedTemplateLiteral(["\n  position: relative;\n  color: green;\n"]);

    _templateObject = function _templateObject() {
      return data;
    };

    return data;
  }
  var Content = styled.div(_templateObject());
  var Container = styled.div(_templateObject2());
  var mouseHoverEvent;

  function _onMouseEnter(delay, setHoverState) {
    mouseHoverEvent = setTimeout(function () {
      return setHoverState(true);
    }, delay);
  }

  function _onMouseLeave(setHoverState) {
    if (mouseHoverEvent) {
      clearTimeout(mouseHoverEvent);
    }

    setHoverState(false);
  }

  function HoverCard(props) {
    var _useState = React.useState(false),
        _useState2 = _slicedToArray(_useState, 2),
        hovered = _useState2[0],
        setHoverState = _useState2[1];

    return React.createElement(Container, {
      onMouseEnter: function onMouseEnter() {
        return _onMouseEnter(props.delay, setHoverState);
      },
      onMouseLeave: function onMouseLeave() {
        return _onMouseLeave(setHoverState);
      }
    }, React.createElement(Content, null, props.children), hovered && props.hoverContent());
  }

  HoverCard.defaultProps = {
    hoverContent: function hoverContent() {
      return null;
    },
    delay: 1000
  };

  function _templateObject$1() {
    var data = _taggedTemplateLiteral(["\n  background-color: white;\n  color: #000;\n  border-radius: 5px;\n  padding: 10px;\n  position: absolute;\n  box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.1);\n"]);

    _templateObject$1 = function _templateObject() {
      return data;
    };

    return data;
  }
  var Card = styled.div(_templateObject$1());

  exports.default = HoverCard;
  exports.Card = Card;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
